'RELAISSTEUERUNG BER LPT1 v1.0
'by Michael Sandberger
'15/12/2001
'PRJ#001a


DECLARE SUB EinAus ()                       'Deklarationen
DECLARE SUB Blinker ()                      'der Unterprogramme
DECLARE SUB Zeitschaltuhr ()
DECLARE SUB Countdown ()

DIM SHARED basis                            'Setzen der Basisadresse
basis = 888                                 'von LPT1

Anfang:                             
SCREEN 0
COLOR 14, 1
CLS
LOCATE 2, 25
PRINT "ͻ"
LOCATE 3, 25
PRINT " RELAISSTEUERUNG BER LPT1 "
LOCATE 4, 25
PRINT "ͼ"
LOCATE 7, 30
PRINT "<1> Ein/Aus"
LOCATE 8, 30
PRINT "<2> Blinker"
LOCATE 9, 30
PRINT "<3> Zeitschaltuhr"
LOCATE 10, 30
PRINT "<4> Countdown"
LOCATE 12, 30
PRINT "<S> Basisadresse =";
PRINT basis
LOCATE 14, 30
PRINT "<Esc> ENDE"


SELECT CASE INPUT$(1)                       'Auswahl der einzelnen
                                            'Funktionen

CASE "1":

SOUND 1000, 1
CALL EinAus
GOTO Anfang


CASE "2":
SOUND 1000, 1
CALL Blinker
GOTO Anfang


CASE "3":
SOUND 1000, 1
CALL Zeitschaltuhr
GOTO Anfang


CASE "4":
SOUND 1000, 1
CALL Countdown
GOTO Anfang


CASE "s":
LOCATE 12, 47
INPUT "= ", basis
SOUND 1000, 1
GOTO Anfang


CASE CHR$(27)
GOTO Ende


CASE ELSE:
LOCATE 16, 28
PRINT "UNGLTIGE EINGABE!"
SOUND 50, 10
SLEEP 1
GOTO Anfang


END SELECT


Ende:

OUT basis, 0                                'Relais aus
SOUND 100, 4
SOUND 50, 4
COLOR 7, 0
CLS

SUB Blinker


Anfang2:
SCREEN 0
CLS
LOCATE 2, 35
PRINT "BLINKER"
LOCATE 3, 35
PRINT "======="
LOCATE 6, 2
INPUT "Blinkintervall eingeben: ", inter
SOUND 1000, 1

IF inter < 10 THEN
LOCATE 16, 28
PRINT "INTERVALL ZU KLEIN!"
SOUND 50, 10
SLEEP 1
LOCATE 16, 28
PRINT SPC(30);
GOTO Anfang2
END IF


DO                                             'Blink-Prozedur

OUT basis, 1                                   'Relais ein
LOCATE 10, 30
PRINT "Relaisstatus: EIN"

i = 0                                          'Verzgerungsschleife
DO                                             'abhngig von inter
i = i + 1

LOOP WHILE i < (inter * 1000)

OUT basis, 0                                   'Relais aus
LOCATE 10, 30
PRINT "Relaisstatus: AUS"

i = 0
DO
i = i + 1
LOOP WHILE i < (inter * 1000)


LOOP WHILE INKEY$ <> CHR$(27)                 'Prozedur luft bis
                                              '<Esc> gedrckt wird

Ende2:
SOUND 100, 4
SOUND 50, 4
                                                  

END SUB

SUB Countdown


SCREEN 0
CLS
LOCATE 2, 35
PRINT "COUNTDOWN"
LOCATE 3, 35
PRINT "========="

LOCATE 6, 2
INPUT "Sekunden: ", sek
SOUND 1000, 1

LOCATE 8, 2
PRINT "<1> Anzugverzgerung"
LOCATE 9, 2
PRINT "<2> Abfallverzgerung"


SELECT CASE INPUT$(1)                       'Auswahlprozedur fr Modus


CASE "1":                                   'Anzugverzgerung

SOUND 1000, 1
OUT basis, 0
LOCATE 17, 32
PRINT "Relaisstatus: AUS"

DO

LOCATE 15, 37                               'Ausgabe der Restzeit
PRINT sek
PRINT SPC(10);
SLEEP 1                                     '1 Sekunde Pause
sek = sek - 1

IF sek <= 10 THEN                           'Tonausgabe bei den
SOUND 800, 1                                'letzten 10 Sekunden
END IF

LOOP WHILE sek > 0
                                            'Fehlerkorrektur:
sek = 0                                     'Countdown sonst 1 Sekunde
LOCATE 15, 37                               'lnger als eingegeben
PRINT sek

OUT basis, 1
SOUND 1000, 1
LOCATE 17, 32
PRINT "Relaisstatus: EIN"

DO                                          'Ende wenn <Esc> gedrckt wird
LOOP WHILE INKEY$ <> CHR$(27)


CASE "2":                                   'Abfallverzgerung

SOUND 1000, 1
OUT basis, 1
LOCATE 17, 32
PRINT "Relaisstatus: EIN"

DO

LOCATE 15, 37                               'Ausgabe der Restzeit
PRINT sek
PRINT SPC(10);
SLEEP 1                                     '1 Sekunde Pause
sek = sek - 1

IF sek <= 10 THEN                           'Tonausgabe bei den
SOUND 800, 1                                'letzten 10 Sekunden
END IF

LOOP WHILE sek > 0
                                            'Fehlerkorrektur:
sek = 0                                     'Countdown sonst 1 Sekunde
LOCATE 15, 37                               'lnger als eingegeben
PRINT sek

OUT basis, 0
SOUND 1000, 1
LOCATE 17, 32
PRINT "Relaisstatus: AUS"

DO                                          'Ende wenn <Esc> gedrckt wird
LOOP WHILE INKEY$ <> CHR$(27)


END SELECT


Ende4:
OUT basis, 0
LOCATE 17, 32
PRINT "Relaisstatus: AUS"
SOUND 100, 4
SOUND 50, 4


END SUB

SUB EinAus


SCREEN 0
CLS
LOCATE 2, 30
PRINT "EIN-/AUSSCHALTUNG"
LOCATE 3, 30
PRINT "================="

LOCATE 7, 2
PRINT "<E>...Ein"
LOCATE 8, 2
PRINT "<A>...Aus"
LOCATE 9, 2
PRINT "<Esc>... ENDE"

OUT basis, 0                                 'Relais aus
LOCATE 12, 30
PRINT "Relaisstatus: AUS"

Anfang1:
SELECT CASE INPUT$(1)                        'E/A-Prozedur


CASE "e":                                    'Relais wird durch Taste <e>
                                             'eingeschaltet
OUT basis, 1
LOCATE 12, 30
PRINT "Relaisstatus: EIN"
SOUND 1000, 1
GOTO Anfang1


CASE "a":                                    'Relais wird durch Taste <a>
                                             'ausgeschaltet
OUT basis, 0
LOCATE 12, 30
PRINT "Relaisstatus: AUS"
SOUND 1000, 1
GOTO Anfang1


CASE CHR$(27):                               'Prozedur wird solange
                                             'wiederholt, bis <Esc>
OUT basis, 0                                 'gedrckt wird
LOCATE 12, 30
PRINT "Relaisstatus: AUS"
SOUND 100, 4
SOUND 50, 4


END SELECT


END SUB

SUB Zeitschaltuhr


SCREEN 0
CLS
LOCATE 2, 30
PRINT "ZEITSCHALTUHR"
LOCATE 3, 30
PRINT "============="

LOCATE 5, 2
PRINT TIME$
PRINT "<S>..Uhrzeit ndern: ";
IF INPUT$(1) = "s" THEN
LINE INPUT zeitneu$
SOUND 1000, 1
TIME$ = zeitneu$
END IF

LOCATE 8, 2
PRINT "Schaltzeit: ";
LINE INPUT schaltzeit$
SOUND 1000, 1

Anfang3:
LOCATE 10, 2
PRINT "<1>...Einschalten"
LOCATE 11, 2
PRINT "<2>...Ausschalten"


SELECT CASE INPUT$(1)


CASE "1":                                  'zu eingegebener Zeit
                                           'zieht Relais an
SOUND 1000, 1
OUT basis, 0
LOCATE 17, 27
PRINT "Relaisstatus: AUS"

DO

LOCATE 15, 30                              'Zeitanzeige
PRINT TIME$

IF INKEY$ = CHR$(27) THEN                  'vorzeitiger Abbruch
GOTO Ende3                                 'mit <Esc>
END IF

LOOP UNTIL TIME$ = schaltzeit$             'Schleife luft solange
                                           'bis die Uhrzeit der
OUT basis, 1                               'Schaltzeit entspricht
LOCATE 17, 27
PRINT "Relaisstatus: EIN"
SOUND 1000, 1

                           
CASE "2":                                  'zu eingegebener Zeit
SOUND 1000, 1                              'fllt Relais ab
OUT basis, 1
LOCATE 17, 27
PRINT "Relaisstatus: EIN"

DO

LOCATE 15, 30                              'Zeitanzeige
PRINT TIME$

IF INKEY$ = CHR$(27) THEN                  'vorzeitiger Abbruch
GOTO Ende3                                 'mit <Esc>
END IF

LOOP UNTIL TIME$ = schaltzeit$             'Schleife luft solange
                                           'bis die Uhrzeit der
OUT basis, 0                               'Schaltzeit entspricht
LOCATE 17, 27
PRINT "Relaisstatus: AUS"
SOUND 1000, 1


CASE ELSE:

LOCATE 16, 28
PRINT "UNGLTIGE EINGABE!"
SOUND 50, 10
SLEEP 1
LOCATE 16, 28
PRINT SPC(30);
GOTO Anfang3


END SELECT


DO

LOCATE 15, 30                              'Zeitanzeige
PRINT TIME$

LOOP WHILE INKEY$ <> CHR$(27)              'Prozedur luft solange
                                           'bis <Esc> gedrckt wird

Ende3:
OUT basis, 0
SOUND 100, 4
SOUND 50, 4

END SUB

